/* input.c generated by valac 0.38.7, the Vala compiler
 * generated from input.vala, do not modify */

/*   FILE: input.vala -- Handle input either from a PiFace CAD or the keyboard.
 * AUTHOR: W. Michael Petullo <mike@flyn.org>
 *   DATE: 22 February 2018
 *
 * Copyright (c) 2018 W. Michael Petullo <new@flyn.org>
 * All rights reserved.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
/* The PiFace CAD provides the following inputs:
 *   From left to right:
 *     Button 0 = 0
 *     Button 1 = 1
 *     Button 2 = 2
 *     Button 3 = 3
 *     Button 4 = 4
 *   Rocker switch:
 *     Select     = 5
 *     Rock left  = 6
 *     Rock right = 7
 */

#include <glib.h>
#include <glib-object.h>
#include <pifacecad.h>
#include <unistd.h>
#include <stdio.h>


#define TYPE_SWITCH_NUMBER (switch_number_get_type ())

#define TYPE_KEY_NUMBER (key_number_get_type ())

#define TYPE_INPUT (input_get_type ())
#define INPUT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_INPUT, Input))
#define INPUT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_INPUT, InputClass))
#define IS_INPUT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_INPUT))
#define IS_INPUT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_INPUT))
#define INPUT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_INPUT, InputClass))

typedef struct _Input Input;
typedef struct _InputClass InputClass;
typedef struct _InputPrivate InputPrivate;
enum  {
	INPUT_0_PROPERTY,
	INPUT_NUM_PROPERTIES
};
static GParamSpec* input_properties[INPUT_NUM_PROPERTIES];
typedef struct _Block1Data Block1Data;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_io_channel_unref0(var) ((var == NULL) ? NULL : (var = (g_io_channel_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
enum  {
	INPUT_STOP_SIGNAL,
	INPUT_SEEKBACK_SIGNAL,
	INPUT_PAUSEPLAY_SIGNAL,
	INPUT_SEEKFORWARD_SIGNAL,
	INPUT_ESCAPE_SIGNAL,
	INPUT_LEFT_SIGNAL,
	INPUT_RIGHT_SIGNAL,
	INPUT_SELECT_SIGNAL,
	INPUT_NUM_SIGNALS
};
static guint input_signals[INPUT_NUM_SIGNALS] = {0};

typedef enum  {
	SWITCH_NUMBER_STOP = 0,
	SWITCH_NUMBER_SEEKBACK = 1,
	SWITCH_NUMBER_PAUSEPLAY = 2,
	SWITCH_NUMBER_SEEKFORWARD = 3,
	SWITCH_NUMBER_ESCAPE = 4,
	SWITCH_NUMBER_SELECT = 5,
	SWITCH_NUMBER_LEFT = 6,
	SWITCH_NUMBER_RIGHT = 7
} SwitchNumber;

typedef enum  {
	KEY_NUMBER_STOP = 'z',
	KEY_NUMBER_SEEKBACK = 'q',
	KEY_NUMBER_PAUSEPLAY = ' ',
	KEY_NUMBER_SEEKFORWARD = 'w',
	KEY_NUMBER_ESCAPE = 0x1b,
	KEY_NUMBER_SELECT = '\n',
	KEY_NUMBER_LEFT = 'a',
	KEY_NUMBER_RIGHT = 's'
} KeyNumber;

struct _Input {
	GObject parent_instance;
	InputPrivate * priv;
};

struct _InputClass {
	GObjectClass parent_class;
};

struct _InputPrivate {
	gboolean pifacecad;
	guint lights_out_id;
	guint8* lastSwitchState;
	gint lastSwitchState_length1;
	gint _lastSwitchState_size_;
};

struct _Block1Data {
	int _ref_count_;
	gboolean pifacecad;
};


static gpointer input_parent_class = NULL;
static GOnce input_instance;
static GOnce input_instance = G_ONCE_INIT;

#define LIGHTS_OUT_SECONDS ((guint) 10)
#define SWITCH_POLL_MILLISECONDS ((guint) 1)
GType switch_number_get_type (void) G_GNUC_CONST;
GType key_number_get_type (void) G_GNUC_CONST;
GType input_get_type (void) G_GNUC_CONST;
#define INPUT_GET_PRIVATE(o) (G_TYPE_INSTANCE_GET_PRIVATE ((o), TYPE_INPUT, InputPrivate))
static Input* input_new (gboolean pifacecad);
static Input* input_construct (GType object_type, gboolean pifacecad);
static void input_lights (Input* self);
Input* input_get_instance (gboolean pifacecad);
static Block1Data* block1_data_ref (Block1Data* _data1_);
static void block1_data_unref (void * _userdata_);
static Input* __lambda5_ (Block1Data* _data1_);
void input_register_handlers (Input* self);
static gpointer ___lambda5__gthread_func (gpointer self);
gboolean input_check_keyboard (Input* self, GIOChannel* channel, GIOCondition condition);
static gboolean _input_check_keyboard_gio_func (GIOChannel* source, GIOCondition condition, gpointer self);
gboolean input_check_switches (Input* self);
static gboolean _input_check_switches_gsource_func (gpointer self);
static gboolean ___lambda4_ (Input* self);
static gboolean ____lambda4__gsource_func (gpointer self);
static void input_finalize (GObject * obj);


GType switch_number_get_type (void) {
	static volatile gsize switch_number_type_id__volatile = 0;
	if (g_once_init_enter (&switch_number_type_id__volatile)) {
		static const GEnumValue values[] = {{SWITCH_NUMBER_STOP, "SWITCH_NUMBER_STOP", "stop"}, {SWITCH_NUMBER_SEEKBACK, "SWITCH_NUMBER_SEEKBACK", "seekback"}, {SWITCH_NUMBER_PAUSEPLAY, "SWITCH_NUMBER_PAUSEPLAY", "pauseplay"}, {SWITCH_NUMBER_SEEKFORWARD, "SWITCH_NUMBER_SEEKFORWARD", "seekforward"}, {SWITCH_NUMBER_ESCAPE, "SWITCH_NUMBER_ESCAPE", "escape"}, {SWITCH_NUMBER_SELECT, "SWITCH_NUMBER_SELECT", "select"}, {SWITCH_NUMBER_LEFT, "SWITCH_NUMBER_LEFT", "left"}, {SWITCH_NUMBER_RIGHT, "SWITCH_NUMBER_RIGHT", "right"}, {0, NULL, NULL}};
		GType switch_number_type_id;
		switch_number_type_id = g_enum_register_static ("SwitchNumber", values);
		g_once_init_leave (&switch_number_type_id__volatile, switch_number_type_id);
	}
	return switch_number_type_id__volatile;
}


GType key_number_get_type (void) {
	static volatile gsize key_number_type_id__volatile = 0;
	if (g_once_init_enter (&key_number_type_id__volatile)) {
		static const GEnumValue values[] = {{KEY_NUMBER_STOP, "KEY_NUMBER_STOP", "stop"}, {KEY_NUMBER_SEEKBACK, "KEY_NUMBER_SEEKBACK", "seekback"}, {KEY_NUMBER_PAUSEPLAY, "KEY_NUMBER_PAUSEPLAY", "pauseplay"}, {KEY_NUMBER_SEEKFORWARD, "KEY_NUMBER_SEEKFORWARD", "seekforward"}, {KEY_NUMBER_ESCAPE, "KEY_NUMBER_ESCAPE", "escape"}, {KEY_NUMBER_SELECT, "KEY_NUMBER_SELECT", "select"}, {KEY_NUMBER_LEFT, "KEY_NUMBER_LEFT", "left"}, {KEY_NUMBER_RIGHT, "KEY_NUMBER_RIGHT", "right"}, {0, NULL, NULL}};
		GType key_number_type_id;
		key_number_type_id = g_enum_register_static ("KeyNumber", values);
		g_once_init_leave (&key_number_type_id__volatile, key_number_type_id);
	}
	return key_number_type_id__volatile;
}


static Input* input_construct (GType object_type, gboolean pifacecad) {
	Input * self = NULL;
	gboolean _tmp0_;
	gboolean _tmp1_;
	self = (Input*) g_object_new (object_type, NULL);
	_tmp0_ = pifacecad;
	self->priv->pifacecad = _tmp0_;
	_tmp1_ = pifacecad;
	if (_tmp1_) {
		pifacecad_open ();
	}
	input_lights (self);
	return self;
}


static Input* input_new (gboolean pifacecad) {
	return input_construct (TYPE_INPUT, pifacecad);
}


static Block1Data* block1_data_ref (Block1Data* _data1_) {
	g_atomic_int_inc (&_data1_->_ref_count_);
	return _data1_;
}


static void block1_data_unref (void * _userdata_) {
	Block1Data* _data1_;
	_data1_ = (Block1Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data1_->_ref_count_)) {
		g_slice_free (Block1Data, _data1_);
	}
}


static Input* __lambda5_ (Block1Data* _data1_) {
	Input* result = NULL;
	Input* input = NULL;
	gboolean _tmp0_;
	Input* _tmp1_;
	_tmp0_ = _data1_->pifacecad;
	_tmp1_ = input_new (_tmp0_);
	input = _tmp1_;
	input_register_handlers (input);
	result = input;
	return result;
}


static gpointer ___lambda5__gthread_func (gpointer self) {
	gpointer result;
	result = __lambda5_ (self);
	return result;
}


Input* input_get_instance (gboolean pifacecad) {
	Input* result = NULL;
	Block1Data* _data1_;
	gboolean _tmp0_;
	gconstpointer _tmp1_;
	_data1_ = g_slice_new0 (Block1Data);
	_data1_->_ref_count_ = 1;
	_tmp0_ = pifacecad;
	_data1_->pifacecad = _tmp0_;
	_tmp1_ = g_once (&input_instance, ___lambda5__gthread_func, _data1_);
	result = (Input*) _tmp1_;
	block1_data_unref (_data1_);
	_data1_ = NULL;
	return result;
}


static gboolean _input_check_keyboard_gio_func (GIOChannel* source, GIOCondition condition, gpointer self) {
	gboolean result;
	result = input_check_keyboard ((Input*) self, source, condition);
	return result;
}


static gboolean _input_check_switches_gsource_func (gpointer self) {
	gboolean result;
	result = input_check_switches ((Input*) self);
	return result;
}


void input_register_handlers (Input* self) {
	GError * _inner_error_ = NULL;
	g_return_if_fail (self != NULL);
	{
		GIOChannel* channel = NULL;
		GIOChannel* _tmp0_;
		_tmp0_ = g_io_channel_unix_new (STDIN_FILENO);
		channel = _tmp0_;
		g_io_channel_set_encoding (channel, NULL, &_inner_error_);
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			_g_io_channel_unref0 (channel);
			if (_inner_error_->domain == G_IO_CHANNEL_ERROR) {
				goto __catch0_g_io_channel_error;
			}
			_g_io_channel_unref0 (channel);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return;
		}
		g_io_add_watch (channel, G_IO_IN, _input_check_keyboard_gio_func, self);
		g_timeout_add_full (G_PRIORITY_DEFAULT, SWITCH_POLL_MILLISECONDS, _input_check_switches_gsource_func, g_object_ref (self), g_object_unref);
		_g_io_channel_unref0 (channel);
	}
	goto __finally0;
	__catch0_g_io_channel_error:
	{
		GError* e = NULL;
		e = _inner_error_;
		_inner_error_ = NULL;
		g_error ("input.vala:105: Channel error initializing state");
		_g_error_free0 (e);
	}
	__finally0:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return;
	}
}


static gboolean ___lambda4_ (Input* self) {
	gboolean result = FALSE;
	pifacecad_lcd_backlight_off ();
	result = FALSE;
	return result;
}


static gboolean ____lambda4__gsource_func (gpointer self) {
	gboolean result;
	result = ___lambda4_ ((Input*) self);
	return result;
}


static void input_lights (Input* self) {
	gboolean _tmp0_;
	g_return_if_fail (self != NULL);
	_tmp0_ = self->priv->pifacecad;
	if (_tmp0_) {
		guint _tmp1_;
		guint _tmp3_;
		pifacecad_lcd_backlight_on ();
		_tmp1_ = self->priv->lights_out_id;
		if (((guint) 0) != _tmp1_) {
			guint _tmp2_;
			_tmp2_ = self->priv->lights_out_id;
			g_source_remove (_tmp2_);
		}
		_tmp3_ = g_timeout_add_seconds_full (G_PRIORITY_DEFAULT, LIGHTS_OUT_SECONDS, ____lambda4__gsource_func, g_object_ref (self), g_object_unref);
		self->priv->lights_out_id = _tmp3_;
	}
}


gboolean input_check_switches (Input* self) {
	gboolean result = FALSE;
	gboolean _tmp0_;
	g_return_val_if_fail (self != NULL, FALSE);
	_tmp0_ = self->priv->pifacecad;
	if (!_tmp0_) {
		result = TRUE;
		return result;
	}
	{
		guint8 _switch_ = 0U;
		_switch_ = (guint8) 0;
		{
			gboolean _tmp1_ = FALSE;
			_tmp1_ = TRUE;
			while (TRUE) {
				guint8 _tmp3_;
				guint8 current = 0U;
				guint8 _tmp4_;
				guint8 _tmp5_;
				gboolean _tmp6_ = FALSE;
				guint8 _tmp7_;
				if (!_tmp1_) {
					guint8 _tmp2_;
					_tmp2_ = _switch_;
					_switch_ = _tmp2_ + 1;
				}
				_tmp1_ = FALSE;
				_tmp3_ = _switch_;
				if (!(((gint) _tmp3_) < 8)) {
					break;
				}
				_tmp4_ = _switch_;
				_tmp5_ = pifacecad_read_switch (_tmp4_);
				current = _tmp5_;
				_tmp7_ = current;
				if (0 == ((gint) _tmp7_)) {
					guint8* _tmp8_;
					gint _tmp8__length1;
					guint8 _tmp9_;
					guint8 _tmp10_;
					_tmp8_ = self->priv->lastSwitchState;
					_tmp8__length1 = self->priv->lastSwitchState_length1;
					_tmp9_ = _switch_;
					_tmp10_ = _tmp8_[_tmp9_];
					_tmp6_ = 1 == ((gint) _tmp10_);
				} else {
					_tmp6_ = FALSE;
				}
				if (_tmp6_) {
					guint8 _tmp11_;
					guint8* _tmp12_;
					gint _tmp12__length1;
					guint8 _tmp13_;
					guint8 _tmp14_;
					guint8 _tmp15_;
					_tmp11_ = _switch_;
					switch (_tmp11_) {
						case SWITCH_NUMBER_STOP:
						{
							g_signal_emit (self, input_signals[INPUT_STOP_SIGNAL], 0);
							break;
						}
						case SWITCH_NUMBER_SEEKBACK:
						{
							g_signal_emit (self, input_signals[INPUT_SEEKBACK_SIGNAL], 0);
							break;
						}
						case SWITCH_NUMBER_PAUSEPLAY:
						{
							g_signal_emit (self, input_signals[INPUT_PAUSEPLAY_SIGNAL], 0);
							break;
						}
						case SWITCH_NUMBER_SEEKFORWARD:
						{
							g_signal_emit (self, input_signals[INPUT_SEEKFORWARD_SIGNAL], 0);
							break;
						}
						case SWITCH_NUMBER_ESCAPE:
						{
							g_signal_emit (self, input_signals[INPUT_ESCAPE_SIGNAL], 0);
							break;
						}
						case SWITCH_NUMBER_SELECT:
						{
							g_signal_emit (self, input_signals[INPUT_SELECT_SIGNAL], 0);
							break;
						}
						case SWITCH_NUMBER_LEFT:
						{
							g_signal_emit (self, input_signals[INPUT_LEFT_SIGNAL], 0);
							break;
						}
						case SWITCH_NUMBER_RIGHT:
						{
							g_signal_emit (self, input_signals[INPUT_RIGHT_SIGNAL], 0);
							break;
						}
						default:
						{
							g_warning ("input.vala:158: Invalid key pressed");
							break;
						}
					}
					input_lights (self);
					_tmp12_ = self->priv->lastSwitchState;
					_tmp12__length1 = self->priv->lastSwitchState_length1;
					_tmp13_ = _switch_;
					_tmp14_ = current;
					_tmp12_[_tmp13_] = _tmp14_;
					_tmp15_ = _tmp12_[_tmp13_];
				}
			}
		}
	}
	result = TRUE;
	return result;
}


gboolean input_check_keyboard (Input* self, GIOChannel* channel, GIOCondition condition) {
	gboolean result = FALSE;
	gchar* c = NULL;
	gchar* _tmp0_;
	gint c_length1;
	gint _c_size_;
	GIOCondition _tmp1_;
	gchar* _tmp19_;
	gint _tmp19__length1;
	gchar _tmp20_;
	GError * _inner_error_ = NULL;
	g_return_val_if_fail (self != NULL, FALSE);
	g_return_val_if_fail (channel != NULL, FALSE);
	_tmp0_ = g_new0 (gchar, 1);
	c = _tmp0_;
	c_length1 = 1;
	_c_size_ = c_length1;
	_tmp1_ = condition;
	if (_tmp1_ == G_IO_HUP) {
		FILE* _tmp2_;
		_tmp2_ = stderr;
		fprintf (_tmp2_, "Standard in closed?\n");
		result = FALSE;
		c = (g_free (c), NULL);
		return result;
	}
	{
		gsize length = 0UL;
		GIOStatus status = 0;
		GIOChannel* _tmp3_;
		gchar* _tmp4_;
		gint _tmp4__length1;
		gsize _tmp5_ = 0UL;
		GIOStatus _tmp6_;
		gboolean _tmp8_ = FALSE;
		GIOStatus _tmp9_;
		length = (gsize) -1;
		_tmp3_ = channel;
		_tmp4_ = c;
		_tmp4__length1 = c_length1;
		_tmp6_ = g_io_channel_read_chars (_tmp3_, _tmp4_, _tmp4__length1, &_tmp5_, &_inner_error_);
		length = _tmp5_;
		status = _tmp6_;
		if (G_UNLIKELY (_inner_error_ != NULL)) {
			gboolean _tmp7_ = FALSE;
			if (_inner_error_->domain == G_IO_CHANNEL_ERROR) {
				goto __catch1_g_io_channel_error;
			}
			if (_inner_error_->domain == G_CONVERT_ERROR) {
				goto __catch1_g_convert_error;
			}
			c = (g_free (c), NULL);
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
			g_clear_error (&_inner_error_);
			return _tmp7_;
		}
		_tmp9_ = status;
		if (_tmp9_ == G_IO_STATUS_EOF) {
			_tmp8_ = TRUE;
		} else {
			gsize _tmp10_;
			_tmp10_ = length;
			_tmp8_ = _tmp10_ != ((gsize) 1);
		}
		if (_tmp8_) {
			FILE* _tmp11_;
			_tmp11_ = stderr;
			fprintf (_tmp11_, "Standard in closed?\n");
			result = FALSE;
			c = (g_free (c), NULL);
			return result;
		}
	}
	goto __finally1;
	__catch1_g_io_channel_error:
	{
		GError* e = NULL;
		FILE* _tmp12_;
		GError* _tmp13_;
		const gchar* _tmp14_;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp12_ = stderr;
		_tmp13_ = e;
		_tmp14_ = _tmp13_->message;
		fprintf (_tmp12_, "IOChannelError: %s\n", _tmp14_);
		result = FALSE;
		_g_error_free0 (e);
		c = (g_free (c), NULL);
		return result;
	}
	goto __finally1;
	__catch1_g_convert_error:
	{
		GError* e = NULL;
		FILE* _tmp15_;
		GError* _tmp16_;
		const gchar* _tmp17_;
		e = _inner_error_;
		_inner_error_ = NULL;
		_tmp15_ = stderr;
		_tmp16_ = e;
		_tmp17_ = _tmp16_->message;
		fprintf (_tmp15_, "ConvertError: %s\n", _tmp17_);
		result = FALSE;
		_g_error_free0 (e);
		c = (g_free (c), NULL);
		return result;
	}
	__finally1:
	if (G_UNLIKELY (_inner_error_ != NULL)) {
		gboolean _tmp18_ = FALSE;
		c = (g_free (c), NULL);
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
		g_clear_error (&_inner_error_);
		return _tmp18_;
	}
	_tmp19_ = c;
	_tmp19__length1 = c_length1;
	_tmp20_ = _tmp19_[0];
	switch (_tmp20_) {
		case KEY_NUMBER_STOP:
		{
			g_signal_emit (self, input_signals[INPUT_STOP_SIGNAL], 0);
			break;
		}
		case KEY_NUMBER_SEEKBACK:
		{
			g_signal_emit (self, input_signals[INPUT_SEEKBACK_SIGNAL], 0);
			break;
		}
		case KEY_NUMBER_SEEKFORWARD:
		{
			g_signal_emit (self, input_signals[INPUT_SEEKFORWARD_SIGNAL], 0);
			break;
		}
		case KEY_NUMBER_PAUSEPLAY:
		{
			g_signal_emit (self, input_signals[INPUT_PAUSEPLAY_SIGNAL], 0);
			break;
		}
		case KEY_NUMBER_LEFT:
		{
			g_signal_emit (self, input_signals[INPUT_LEFT_SIGNAL], 0);
			break;
		}
		case KEY_NUMBER_RIGHT:
		{
			g_signal_emit (self, input_signals[INPUT_RIGHT_SIGNAL], 0);
			break;
		}
		case KEY_NUMBER_SELECT:
		{
			g_signal_emit (self, input_signals[INPUT_SELECT_SIGNAL], 0);
			break;
		}
		case KEY_NUMBER_ESCAPE:
		{
			g_signal_emit (self, input_signals[INPUT_ESCAPE_SIGNAL], 0);
			break;
		}
		default:
		{
			gboolean _tmp21_;
			_tmp21_ = self->priv->pifacecad;
			if (_tmp21_) {
				g_warning ("input.vala:220: Invalid key pressed");
			} else {
				FILE* _tmp22_;
				FILE* _tmp23_;
				FILE* _tmp24_;
				FILE* _tmp25_;
				FILE* _tmp26_;
				FILE* _tmp27_;
				FILE* _tmp28_;
				FILE* _tmp29_;
				FILE* _tmp30_;
				_tmp22_ = stderr;
				fprintf (_tmp22_, "Valid keys are:\n");
				_tmp23_ = stderr;
				fprintf (_tmp23_, "  'z'     (stop)\n");
				_tmp24_ = stderr;
				fprintf (_tmp24_, "  'q'     (seek backward)\n");
				_tmp25_ = stderr;
				fprintf (_tmp25_, "  'w'     (seek forward)\n");
				_tmp26_ = stderr;
				fprintf (_tmp26_, "  ' '     (pause/play)\n");
				_tmp27_ = stderr;
				fprintf (_tmp27_, "  'a'     (left)\n");
				_tmp28_ = stderr;
				fprintf (_tmp28_, "  's'     (right)\n");
				_tmp29_ = stderr;
				fprintf (_tmp29_, "  'enter' (select)\n");
				_tmp30_ = stderr;
				fprintf (_tmp30_, "  'esc'   (escape)\n");
			}
			break;
		}
	}
	result = TRUE;
	c = (g_free (c), NULL);
	return result;
}


static void input_class_init (InputClass * klass) {
	input_parent_class = g_type_class_peek_parent (klass);
	g_type_class_add_private (klass, sizeof (InputPrivate));
	G_OBJECT_CLASS (klass)->finalize = input_finalize;
	input_signals[INPUT_STOP_SIGNAL] = g_signal_new ("stop", TYPE_INPUT, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	input_signals[INPUT_SEEKBACK_SIGNAL] = g_signal_new ("seekback", TYPE_INPUT, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	input_signals[INPUT_PAUSEPLAY_SIGNAL] = g_signal_new ("pauseplay", TYPE_INPUT, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	input_signals[INPUT_SEEKFORWARD_SIGNAL] = g_signal_new ("seekforward", TYPE_INPUT, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	input_signals[INPUT_ESCAPE_SIGNAL] = g_signal_new ("escape", TYPE_INPUT, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	input_signals[INPUT_LEFT_SIGNAL] = g_signal_new ("left", TYPE_INPUT, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	input_signals[INPUT_RIGHT_SIGNAL] = g_signal_new ("right", TYPE_INPUT, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
	input_signals[INPUT_SELECT_SIGNAL] = g_signal_new ("select", TYPE_INPUT, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
}


static void input_instance_init (Input * self) {
	guint8* _tmp0_;
	self->priv = INPUT_GET_PRIVATE (self);
	self->priv->lights_out_id = (guint) 0;
	_tmp0_ = g_new0 (guint8, 8);
	_tmp0_[0] = (guint8) 1;
	_tmp0_[1] = (guint8) 1;
	_tmp0_[2] = (guint8) 1;
	_tmp0_[3] = (guint8) 1;
	_tmp0_[4] = (guint8) 1;
	_tmp0_[5] = (guint8) 1;
	_tmp0_[6] = (guint8) 1;
	_tmp0_[7] = (guint8) 1;
	self->priv->lastSwitchState = _tmp0_;
	self->priv->lastSwitchState_length1 = 8;
	self->priv->_lastSwitchState_size_ = self->priv->lastSwitchState_length1;
}


static void input_finalize (GObject * obj) {
	Input * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_INPUT, Input);
	self->priv->lastSwitchState = (g_free (self->priv->lastSwitchState), NULL);
	G_OBJECT_CLASS (input_parent_class)->finalize (obj);
}


GType input_get_type (void) {
	static volatile gsize input_type_id__volatile = 0;
	if (g_once_init_enter (&input_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (InputClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) input_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Input), 0, (GInstanceInitFunc) input_instance_init, NULL };
		GType input_type_id;
		input_type_id = g_type_register_static (G_TYPE_OBJECT, "Input", &g_define_type_info, 0);
		g_once_init_leave (&input_type_id__volatile, input_type_id);
	}
	return input_type_id__volatile;
}



