/* output.c generated by valac 0.38.7, the Vala compiler
 * generated from output.vala, do not modify */

/*   FILE: output.vala -- Handle output either to a PiFace CAD or stdout.
 * AUTHOR: W. Michael Petullo <mike@flyn.org>
 *   DATE: 22 February 2018
 *
 * Copyright (c) 2018 W. Michael Petullo <new@flyn.org>
 * All rights reserved.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <stdio.h>


#define TYPE_OUTPUT (output_get_type ())
#define OUTPUT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_OUTPUT, Output))
#define OUTPUT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_OUTPUT, OutputClass))
#define IS_OUTPUT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_OUTPUT))
#define IS_OUTPUT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_OUTPUT))
#define OUTPUT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_OUTPUT, OutputClass))

typedef struct _Output Output;
typedef struct _OutputClass OutputClass;
typedef struct _OutputPrivate OutputPrivate;
enum  {
	OUTPUT_0_PROPERTY,
	OUTPUT_NUM_PROPERTIES
};
static GParamSpec* output_properties[OUTPUT_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_string_free0(var) ((var == NULL) ? NULL : (var = (g_string_free (var, TRUE), NULL)))

struct _Output {
	GObject parent_instance;
	OutputPrivate * priv;
};

struct _OutputClass {
	GObjectClass parent_class;
};


static gpointer output_parent_class = NULL;
static guint output_output_shift;
static guint output_output_shift = (guint) 0;
static gchar* output_output_str;
static gchar* output_output_str = NULL;
extern gboolean no_pifacecad;

GType output_get_type (void) G_GNUC_CONST;
Output* output_new (void);
Output* output_construct (GType object_type);
static gboolean output_render_output (Output* self);
static gboolean _output_render_output_gsource_func (gpointer self);
void output_output (Output* self, const gchar* str);
static void output_finalize (GObject * obj);


static gboolean _output_render_output_gsource_func (gpointer self) {
	gboolean result;
	result = output_render_output ((Output*) self);
	return result;
}


Output* output_construct (GType object_type) {
	Output * self = NULL;
	gboolean _tmp0_;
	self = (Output*) g_object_new (object_type, NULL);
	_tmp0_ = no_pifacecad;
	if (!_tmp0_) {
		g_timeout_add_full (G_PRIORITY_DEFAULT, (guint) 750, _output_render_output_gsource_func, g_object_ref (self), g_object_unref);
	}
	return self;
}


Output* output_new (void) {
	return output_construct (TYPE_OUTPUT);
}


static glong string_strnlen (gchar* str, glong maxlen) {
	glong result = 0L;
	gchar* end = NULL;
	gchar* _tmp0_;
	glong _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	_tmp0_ = str;
	_tmp1_ = maxlen;
	_tmp2_ = memchr (_tmp0_, 0, (gsize) _tmp1_);
	end = _tmp2_;
	_tmp3_ = end;
	if (_tmp3_ == NULL) {
		glong _tmp4_;
		_tmp4_ = maxlen;
		result = _tmp4_;
		return result;
	} else {
		gchar* _tmp5_;
		gchar* _tmp6_;
		_tmp5_ = end;
		_tmp6_ = str;
		result = (glong) (_tmp5_ - _tmp6_);
		return result;
	}
}


static gchar* string_substring (const gchar* self, glong offset, glong len) {
	gchar* result = NULL;
	glong string_length = 0L;
	gboolean _tmp0_ = FALSE;
	glong _tmp1_;
	glong _tmp8_;
	glong _tmp14_;
	glong _tmp17_;
	glong _tmp18_;
	glong _tmp19_;
	glong _tmp20_;
	glong _tmp21_;
	gchar* _tmp22_;
	g_return_val_if_fail (self != NULL, NULL);
	_tmp1_ = offset;
	if (_tmp1_ >= ((glong) 0)) {
		glong _tmp2_;
		_tmp2_ = len;
		_tmp0_ = _tmp2_ >= ((glong) 0);
	} else {
		_tmp0_ = FALSE;
	}
	if (_tmp0_) {
		glong _tmp3_;
		glong _tmp4_;
		glong _tmp5_;
		_tmp3_ = offset;
		_tmp4_ = len;
		_tmp5_ = string_strnlen ((gchar*) self, _tmp3_ + _tmp4_);
		string_length = _tmp5_;
	} else {
		gint _tmp6_;
		gint _tmp7_;
		_tmp6_ = strlen (self);
		_tmp7_ = _tmp6_;
		string_length = (glong) _tmp7_;
	}
	_tmp8_ = offset;
	if (_tmp8_ < ((glong) 0)) {
		glong _tmp9_;
		glong _tmp10_;
		glong _tmp11_;
		_tmp9_ = string_length;
		_tmp10_ = offset;
		offset = _tmp9_ + _tmp10_;
		_tmp11_ = offset;
		g_return_val_if_fail (_tmp11_ >= ((glong) 0), NULL);
	} else {
		glong _tmp12_;
		glong _tmp13_;
		_tmp12_ = offset;
		_tmp13_ = string_length;
		g_return_val_if_fail (_tmp12_ <= _tmp13_, NULL);
	}
	_tmp14_ = len;
	if (_tmp14_ < ((glong) 0)) {
		glong _tmp15_;
		glong _tmp16_;
		_tmp15_ = string_length;
		_tmp16_ = offset;
		len = _tmp15_ - _tmp16_;
	}
	_tmp17_ = offset;
	_tmp18_ = len;
	_tmp19_ = string_length;
	g_return_val_if_fail ((_tmp17_ + _tmp18_) <= _tmp19_, NULL);
	_tmp20_ = offset;
	_tmp21_ = len;
	_tmp22_ = g_strndup (((gchar*) self) + _tmp20_, (gsize) _tmp21_);
	result = _tmp22_;
	return result;
}


static gboolean output_render_output (Output* self) {
	gboolean result = FALSE;
	const gchar* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	g_return_val_if_fail (self != NULL, FALSE);
	pifacecad_lcd_clear ();
	_tmp0_ = output_output_str;
	_tmp1_ = strlen (_tmp0_);
	_tmp2_ = _tmp1_;
	if (_tmp2_ <= 15) {
		const gchar* _tmp3_;
		_tmp3_ = output_output_str;
		pifacecad_lcd_write (_tmp3_);
	} else {
		GString* builder = NULL;
		GString* _tmp4_;
		gint _tmp5_ = 0;
		const gchar* _tmp6_;
		gint _tmp7_;
		gint _tmp8_;
		guint rest = 0U;
		gint _tmp12_ = 0;
		const gchar* _tmp13_;
		gint _tmp14_;
		gint _tmp15_;
		guint cutoff = 0U;
		GString* _tmp19_;
		const gchar* _tmp20_;
		guint _tmp21_;
		gchar* _tmp22_;
		gchar* _tmp23_;
		GString* _tmp24_;
		GString* _tmp25_;
		const gchar* _tmp26_;
		guint _tmp27_;
		guint _tmp28_;
		gchar* _tmp29_;
		gchar* _tmp30_;
		GString* _tmp31_;
		const gchar* _tmp32_;
		guint _tmp33_ = 0U;
		guint _tmp34_;
		guint _tmp35_;
		_tmp4_ = g_string_new ("");
		builder = _tmp4_;
		_tmp6_ = output_output_str;
		_tmp7_ = strlen (_tmp6_);
		_tmp8_ = _tmp7_;
		if (_tmp8_ > 30) {
			_tmp5_ = 15;
		} else {
			const gchar* _tmp9_;
			gint _tmp10_;
			gint _tmp11_;
			_tmp9_ = output_output_str;
			_tmp10_ = strlen (_tmp9_);
			_tmp11_ = _tmp10_;
			_tmp5_ = _tmp11_ - 15;
		}
		rest = (guint) _tmp5_;
		_tmp13_ = output_output_str;
		_tmp14_ = strlen (_tmp13_);
		_tmp15_ = _tmp14_;
		if (_tmp15_ > 30) {
			const gchar* _tmp16_;
			gint _tmp17_;
			gint _tmp18_;
			_tmp16_ = output_output_str;
			_tmp17_ = strlen (_tmp16_);
			_tmp18_ = _tmp17_;
			_tmp12_ = _tmp18_ - 30;
		} else {
			_tmp12_ = 0;
		}
		cutoff = (guint) _tmp12_;
		_tmp19_ = builder;
		_tmp20_ = output_output_str;
		_tmp21_ = output_output_shift;
		_tmp22_ = string_substring (_tmp20_, (glong) _tmp21_, (glong) 15);
		_tmp23_ = _tmp22_;
		g_string_append (_tmp19_, _tmp23_);
		_g_free0 (_tmp23_);
		_tmp24_ = builder;
		g_string_append (_tmp24_, "\n ");
		_tmp25_ = builder;
		_tmp26_ = output_output_str;
		_tmp27_ = output_output_shift;
		_tmp28_ = rest;
		_tmp29_ = string_substring (_tmp26_, (glong) (15 + _tmp27_), (glong) _tmp28_);
		_tmp30_ = _tmp29_;
		g_string_append (_tmp25_, _tmp30_);
		_g_free0 (_tmp30_);
		_tmp31_ = builder;
		_tmp32_ = _tmp31_->str;
		pifacecad_lcd_write (_tmp32_);
		_tmp34_ = output_output_shift;
		_tmp35_ = cutoff;
		if (_tmp34_ < _tmp35_) {
			guint _tmp36_;
			_tmp36_ = output_output_shift;
			_tmp33_ = _tmp36_ + 1;
		} else {
			_tmp33_ = (guint) 0;
		}
		output_output_shift = _tmp33_;
		_g_string_free0 (builder);
	}
	result = TRUE;
	return result;
}


void output_output (Output* self, const gchar* str) {
	FILE* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	gboolean _tmp4_;
	g_return_if_fail (self != NULL);
	g_return_if_fail (str != NULL);
	_tmp0_ = stdout;
	_tmp1_ = str;
	fprintf (_tmp0_, "%s\n", _tmp1_);
	output_output_shift = (guint) 0;
	_tmp2_ = str;
	_tmp3_ = g_strdup (_tmp2_);
	_g_free0 (output_output_str);
	output_output_str = _tmp3_;
	_tmp4_ = no_pifacecad;
	if (!_tmp4_) {
		output_render_output (self);
	}
}


static void output_class_init (OutputClass * klass) {
	gchar* _tmp0_;
	output_parent_class = g_type_class_peek_parent (klass);
	G_OBJECT_CLASS (klass)->finalize = output_finalize;
	_tmp0_ = g_strdup ("");
	output_output_str = _tmp0_;
}


static void output_instance_init (Output * self) {
}


static void output_finalize (GObject * obj) {
	Output * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_OUTPUT, Output);
	G_OBJECT_CLASS (output_parent_class)->finalize (obj);
}


GType output_get_type (void) {
	static volatile gsize output_type_id__volatile = 0;
	if (g_once_init_enter (&output_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (OutputClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) output_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Output), 0, (GInstanceInitFunc) output_instance_init, NULL };
		GType output_type_id;
		output_type_id = g_type_register_static (G_TYPE_OBJECT, "Output", &g_define_type_info, 0);
		g_once_init_leave (&output_type_id__volatile, output_type_id);
	}
	return output_type_id__volatile;
}



